#ifndef __CHANSERV_H
#define __CHANSERV_H

/* mode flags */
#define PM_I  0x00000001
#define PM_K  0x00000002
#define PM_L  0x00000004
#define PM_M  0x00000008
#define PM_N  0x00000010
#define PM_P  0x00000020
#define PM_S  0x00000040
#define PM_T  0x00000080
#define MM_I  0x00000100
#define MM_K  0x00000200
#define MM_L  0x00000400
#define MM_M  0x00000800
#define MM_N  0x00001000
#define MM_P  0x00002000
#define MM_S  0x00004000
#define MM_T  0x00008000
#define PM_C  0x00010000
#define MM_C  0x00020000
#define PM_R  0x00040000
#define MM_R  0x00080000
#define PM_Q  0x00100000
#define MM_Q  0x00200000
#define PM_s  0x00400000
#define MM_s  0x00800000
#define PM_c  0x01000000
#define MM_c  0x02000000

/* Channel flags */
#define COPGUARD  0x00000001
#define CKTOPIC   0x00000002
#define CLEAVEOPS 0x00000004
#define CQUIET    0x00000008
#define CNOOP     0x00000010
#define CHOLD     0x00000040
#define CREG      0x00000080
#define CBANISH   0x00000100
#define CPROTOP   0x00000200
#define CFEXEMPT  0x00000800
#define CNOTICE   0x00002000
#define CFORCES   0x00004000
#define CFREEZE   0x00008000
#define CCLOSED   0x00020000

/*
 * op levels.
 *
 * Anything named OPxx is an open field.
 * feel free to fill open fields with whatever you want
 * For more information, see docs/levelscheme.
 */
#define OPNONE       0
#define OP1          1
#define OP2          2
#define MAOP         3
#define HOP          4
#define AOP          5
#define OP6          6
#define OP7          7
#define MSOP         8
#define OP9          9
#define SOP         10
#define OP11        11
#define OP12        12
#define MFOUNDER    13
#define OP14        14
#define FOUNDER     15

typedef struct cnicklist_struct cNickList;

struct cnicklist_struct {
  UserList       *person; /* Pointer to persons user info */
  int             op;
  cNickList      *next;
  cNickList      *previous;
  cNickList      *hashnext;
  cNickList      *hashprev;
};

typedef struct cnicklisthashent_struct {
  cNickList      *item;
  cNickList      *lastitem;
} cNickListHashEnt;

/*
 * This is used for AOP/SOP/Foundererer lists 
 */
typedef struct caccesslist_struct cAccessList;

struct caccesslist_struct {
  char            nick[NICKLEN];
  short           uflags;   /* flags:  AOP/SOP/CFOUNDER/RFOUNDER */
  int index;
  cAccessList    *next;
  cAccessList    *previous;
  cAccessList    *hashnext;
  cAccessList    *hashprev;
};

typedef struct caccesslisthashent_struct {
  cAccessList    *item, *lastitem;
} cAccessListHashEnt;

/*
 * Special list for AKicked lusers, }:> 
 */
typedef struct cakicklist_struct cAkickList;

struct cakicklist_struct {
  char            mask[USERLEN+HOSTLEN+3];
  char            reason[51 + NICKLEN];   /* Why they're AKicked */
  int index;
  time_t          added;      /* When it was set */
  cAkickList     *next;
  cAkickList     *previous;
};

/*
 * Ban item 
 */
typedef struct cbanlist_struct cBanList;

struct cbanlist_struct {
  char            ban[NICKLEN + USERLEN + HOSTLEN]; /* the ban */
  cBanList       *next;
  cBanList       *previous;
};

/*
 * tis a channel we see...arr me maties...
 * ^^^ and just what was I smoking when I wrote this stuff? :P
 */

typedef struct regchanlist_struct RegChanList;

struct chanlist_struct {
  char name[CHANLEN];
  cBanList       *firstBan; /* list of banned people */
  cBanList       *lastBan;
  cNickList      *firstUser;
  cNickList      *lastUser;
  long modes;
  RegChanList *reg;
  ChanList *next, *previous, *hashnext, *hashprev;
};

struct regchanlist_struct {
  char            name[CHANLEN];  /* channel name */
  char            founder[NICKLEN];
  int             facc;
  char            desc[101];  /* description */
  char            topic[310]; /* the topic */
  char            tsetby[NICKLEN];  /* Who set the topic */
  char            url[128];
  char            password[16];
  time_t          ttimestamp; /* when the topic was set */
  long            mlock;  /* modelocks (+/-) */
  long            flags;  /* Channel flags */
  time_t          timereg;
  time_t          timestamp;
  char            key[23];  /* Channel key */
  long            limit;  /* limit */
  int             ops;    /* how many of each are there */
  int             akicks;
  int             tlocklevel;
  int             restrictlevel;
  cAkickList     *firstAkick; /* Banned users */
  cAkickList     *lastAkick;
  /*
   * hashes for users/ChanOps 
   */
  cAccessList    *firstOp;
  cAccessList    *lastOp;
  RegChanList       *next;
  RegChanList       *previous;
  RegChanList       *hashnext;
  RegChanList       *hashprev;
};

typedef struct forcelist_struct ForceList;

struct forcelist_struct {
  char mask[CHANLEN];
  ForceList *next, *prev;
};

void addForce(char *);
int isForced(char *);

typedef struct banchanlist_struct BanChannelList;

struct banchanlist_struct {
  char mask[CHANLEN];
  BanChannelList *next, *prev;
};

void addBanChannel(char *);
int isBanChannel(char *);

void            sendToChanServ(UserList *, char **, int);
void            addUserToChan(UserList *, char *);
void            remUserFromChan(UserList *, char *);
void doKick(UserList *, UserList *, char *);
void            remFromAllChans(UserList *);
void            changeNickOnAllChans(UserList *, UserList *);
void            setChanMode(char **, int);
void            setChanTopic(char **, int);
void            sendToChanOps(ChanList *, char *,...);
void            cleanChanList(void);
void addChan(ChanList *);
void delChan(ChanList *);
void addRegChan(RegChanList *);
void delRegChan(RegChanList *);
void addChanAkick(RegChanList *, cAkickList *);
void delChanAkick(RegChanList *, cAkickList *);
void addChanOp(RegChanList *, cAccessList *);
void delChanOp(RegChanList *, cAccessList *);
void initRegChanData(RegChanList *);
void addChanUser(ChanList *, cNickList *);
void delChanUser(ChanList *, cNickList *);
void addChanBan(ChanList *, cBanList *);
void delChanBan(ChanList *, cBanList *);
ChanList *getChanData(char *);
RegChanList *getRegChanData(char *);
cNickList *getChanUserData(ChanList *, UserList *);
cBanList *getChanBan(ChanList *, char *);
int getChanOp(RegChanList *, char *);
cAccessList *getChanOpData(RegChanList *, char *);
cAkickList *getChanAKick(RegChanList *, char *);
void syncChanData(time_t);
int check_mask(char *, int);
int countRegChans(char *);
void remfromallchanops(char *);
void ParseSJOIN(char *, char*);
void addUserToChanSJ(UserList *, char *, int);

/* chanserv commands prototypes: */

void CclistCmd(UserList *, char **, int);
void CinfoCmd(UserList *, char **, int);
void CregisterCmd(UserList *, char **, int);
void CdropCmd(UserList *, char **, int);
void CaccessCmd(UserList *, char **, int);  
void CaddopCmd(UserList *, char **, int);
void CaddakCmd(UserList *, char **, int);  
void CdelopCmd(UserList *, char **, int);
void CdelakCmd(UserList *, char **, int);
void ClistopCmd(UserList *, char **, int);
void ClistakCmd(UserList *, char **, int);
void CopCmd(UserList *, char **, int);
void CdeopCmd(UserList *, char **, int);  
void CmodelockCmd(UserList *, char **, int);
void CrestrictCmd(UserList *, char **, int);
void CtopiclockCmd(UserList *, char **, int);
void CsetCmd(UserList *, char **, int);
void CsaveCmd(UserList *, char **, int);
void CinviteCmd(UserList *, char **, int);
void CunbanCmd(UserList *, char **, int);
void ClistCmd(UserList *, char **, int);
void CdeleteCmd(UserList *, char **, int);
void CmassdeopCmd(UserList *, char **, int);
void CmasskickCmd(UserList *, char **, int);
void CmodeclearCmd(UserList *, char **, int);
void CfounderCmd(UserList *, char **, int);
void CcloseCmd(UserList *, char **, int);

/* Added by bobby */
void CaccesslistCmd(UserList *, char **, int);
void ClistoplCmd(UserList *, char **, int);

#define CHANOP 0x0001
#define CHANVOICE 0x0002
#define CHANHALFOP 0x0004

#endif /* __CHANSERV_H */
