/*
 * Copyright (c) 1999-2000 GZ
 * Copyright (c) 1998 Bill Jones
 * Copyright (c) 1997 Max Byrd
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS `AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "services.h"


/*
 * this func borrowed from DALnet ircd, and such 
 */
long getHashKey(char *hname)
{
  unsigned char  *name = (unsigned char *) hname;
  long            hash = 0x00005555;

  for (; *name; name++)
    hash = (hash << 2) ^ tolower(*name);

  if (hash < 0)
    hash = -hash;
  return (hash);
}

/*
 * clean hash tables, one for each table 
 */

void cleanNickHash(void)
{
  long i;

  for (i = 0; i < NICKHASHSIZE; i++) {
    RegNickHash[i].nick = RegNickHash[i].lastnick = NULL;
    UserHash[i].nick = UserHash[i].lastnick = NULL;
  }
  for (i=0;i<CLONEHASHSIZE;i++) {
    CloneHash[i].clone = CloneHash[i].lastclone = NULL;
  }
  return;
}

void cleanChanHash(void)
{
  long i;

  for (i = 0; i < CHANHASHSIZE; i++) {
    RegChanHash[i].chan = RegChanHash[i].lastchan = NULL;
    ChanHash[i].chan = ChanHash[i].lastchan = NULL;
  }
  return;
}
