/*
 * Copyright (c) 2001 bobby
 * Copyright (c) 1999-2000 GZ
 * Copyright (c) 1998 Bill Jones
 * Copyright (c) 1997 Max Byrd
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS `AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "services.h"

/* Used for parsing of the helpdata */
char tmpstr[81];

char *parsestr(char *str) {

  char *s1, *s2;
      
  s2 = tmpstr;
  bzero(tmpstr,81);
                
  for (s1 = str; *s1; s1++) {  
    if (*s1 == '%')
      *s2 = '\002';
    else if (*s1 == '&')
      *s2 = '\x1f';
    else
      *s2 = *s1;
    s2++;
  }
  return (char *) tmpstr;
}

char *fixnullstr(char *str) {
  
  char *s1, *s2;
  int allspace = 1; 
        
  for (s1 = str; *s1; s1++) {   
    if (*s1 != ' ') {
      allspace = 0;
      break;
    }
  }              
  
  if (allspace || !*str) {
    strcpy(str," ");
    return str;
  } else {
    s2 = parsestr(str);
    return s2;
  }
} 
   
void sendHelp (char *to, char *service, char *args[511], int numargs) {

  int i;
  char data[81];
  char filename[512];
  char filename2[512];
  char searchargs[512];
  FILE *fp;
  UserList *tmp;

  if (service == NULL)  /* YIPE -- NO SERVICE ASKED FOR THIS */
    return;

  memset(filename, '\0', 511); memset(filename2, '\0', 511);
  strcpy(filename, MYDIR);  strcat(filename, "/");
  strcat(filename2, service); strcat(filename2, "/");

  if (numargs == 0) {
    strcat(filename2, "index.help\0");
    strcpy(searchargs, service);
  } else {
    strcat(filename2, args[1]);
    strcpy(searchargs, args[1]);
    i = 2;
    while (i < numargs) {
      strcat(filename2, "-");
      strcat(filename2, args[i]);
      strcat(searchargs, " ");
      strcat(searchargs, args[i]);
      i++;
    }
    strcat(filename2, ".help\0");
  }

  strtolower(filename2);
  strcat(filename, filename2);
  i = 0;

  fp = fopen(filename, "r");
  if (fp != NULL) {
    tmp = getNickData(to);

    if (tmp) {
      while (sfgets(data, 81, fp)) {
        if (!strncmp(data, "<oper>",6)) {
          while (sfgets(data, 81, fp) && strncmp(data, "</oper>",7)) {
            if (isOper(tmp)) {
              uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
              i++;
            }
          }
        } else if (!strncmp(data, "<servop>",8)) {
          while (sfgets(data, 81, fp) && strncmp(data, "</servop>",9)) {
            if (isServop(tmp)) {
              uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
              i++;
            }
          }
        } else if (!strncmp(data, "<root>",6)) {
          while (sfgets(data, 81, fp) && strncmp(data, "</root>",7)) {
            if (isRoot(tmp)) {
              uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
              i++;
            }
          }
        } else {
          uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
          i++;
        }
      }
    }
    fclose(fp);
  }

  if (!i) {
    tmp = getNickData(to);
    uSend(service, tmp, GetReply(ERR_NOHELPONTHAT, tmp), searchargs);
  }
}
