#ifndef __MEMOSERV_H
#define __MEMOSERV_H

/* various MS flags */
#define MNOMEMO     0x0001
#define MSELFCLEAN  0x0004
#define MFORWARDED  0x0008
#define MNOFORWARD  0x0010

/* memo flags */
#define MEMO_UNREAD 0x0001
#define MEMO_DELETE 0x0002
#define MEMO_SAVE   0x0004
#define MEMO_FWD    0x0008
#define MEMO_REPLY  0x0010

typedef struct memolist MemoList;
struct memolist {
  int flags, index;
  time_t sent;
  char from[NICKLEN + CHANLEN + 1];
  char memo[MEMOLEN];
  MemoList *next, *previous;
};

typedef struct memobox MemoBox;
struct memobox {
  int memos, sent, flags, max;
  time_t lastsent;
  char redirect[NICKLEN];
  MemoList *firstMemo, *lastMemo;
};

void MreadCmd(UserList *, char **, int);
void MlistCmd(UserList *, char **, int);
void MsendCmd(UserList *, char **, int);
void MforwardCmd(UserList *, char **, int);
void McsendCmd(UserList *, char **, int);
void MdeleteCmd(UserList *, char **, int);
void McleanCmd(UserList *, char **, int);
void MsetCmd(UserList *, char **, int);
void MretrieveCmd(UserList *, char **, int);
void initMemoBox(MemoBox *);
void addMemo(MemoBox *, MemoList *);
void delMemo(MemoBox *, MemoList *);
void checkMemos(UserList *);
void cleanMemos(UserList *);
void syncMemoData(time_t);

/*
 * functions 
 */
void            sendToMemoServ(UserList *, char **, int);

#endif /* __MEMOSERV_H */
