/*
 * Copyright (c) 2001 bobby
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS `AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "services.h"

void addNews(NewsItem *news) {

  if (!firstNews) {
    firstNews = news;
    news->previous = NULL;
  } else {
    lastNews->next = news;
    news->previous = lastNews;
  }
  
  lastNews = news;
  news->next = NULL;
}

void delNews(NewsItem *news) {

  if (news->previous)
    news->previous->next = news->next;
  else
    firstNews = news->next;

  if (news->next)
    news->next->previous = news->previous;
  else
    lastNews = news->previous; 

  sfree(news);
}

NewsItem *getNews(int news, int type) {

  NewsItem *nw;
  int  i = 0;

  for (nw = firstNews; nw; nw = nw->next) {
    if (nw->type == type)
      i++;
    if (i == news)
      break;
  }
 
  if (i == news)
    return nw;
  else
    return NULL;
}

void sendNews(UserList *nick, int type) {

  NewsItem *nw;
  int i = 0, total = 0, last = 0, ind = 0;

  for (nw = firstNews; nw; nw = nw->next) {
    if (nw->type == type)
      total++;
  }
 
  if (total > 3)
    last = total - 2;
  else
    last = 1;

  for (i = total; i >= last; i--) {
    nw = getNews(i, type);
    if (nw) {
      ind++;
      if (type == LOGONNEWS)
        uSend(GlobalMessenger, nick, GetReply(RPL_SHOWNEWS, nick), "LOGON", ind, nw->news);
      else if (type == OPERNEWS)
        uSend(GlobalMessenger, nick, GetReply(RPL_SHOWNEWS, nick), "OPER", ind, nw->news);
    }
  }
}
