/*
 *
 * Language handling core code
 *
 *                 GZ (April 2000) 
 */

#include "services.h"
#include "english.h"
#include "spanish.h"

struct LangTable LT[] = {
  { "English",   0, (struct FormatTable *) NULL},
  { "Spanish",   0, (struct FormatTable *) NULL},
  { "-",         0, (struct FormatTable *) NULL}
};

int LoadTables(void) {

  int i, j, z;

  printf("Loading languages...");
  i = 0;

  while (LT[i].language[0] != '-') {
    printf("%s", LT[i].language);

    if (!strcmp(LT[i].language, "English")) 
      LT[i].numtable = EnglishReplies;

    if (!strcmp(LT[i].language, "Spanish")) 
      LT[i].numtable = SpanishReplies;

    j = 0;

    while (LT[i].numtable[j].numeric != -1)
      j++;

    z = LT[i].numtable[j-1].numeric;

    printf("[%i]...", j);
    LT[i].numerics = --j;
    i++;
  }
  printf("\n");
  return 0;
}

char *GetReply(int numeric, UserList *nick) {

  int language;
  
  if (nick->reg)
    language = nick->reg->language;
  else
    language = 0;

  if (numeric > LT[language].numerics)
    language = 0;

  if (numeric > LT[language].numerics)
    strcpy(retnum, "Unknown numeric requested...");
  else
    strcpy(retnum, LT[language].numtable[numeric].format);

  return retnum;
}

char *GetLanguage(UserList *nick) {

  if (nick->reg)
    strcpy(retlanguage, LT[nick->reg->language].language);
  else
    strcpy(retlanguage, "<none>");

  return retlanguage;
}
