/*
 * Copyright (c) 2001 bobby
 * Copyright (c) 1999-2000 GZ
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS `AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* This file contains all possible replies Services will send to users 
 * do not modify unless you know *EXACTLY* how this works.
 *                                  Added   GZ (April 2000)
 *                                Updated   bobby (November 2001)
 */

#ifndef NUMERIC__H
#define NUMERIC__H

char  *GetLanguage(UserList *);
char  *GetReply(int, UserList *);
int   LoadTables();

char  retlanguage[16];

#define RPL_CUSTOM    0
#define ERR_NEEDREGNICK   1
#define ERR_NEEDACTNICK   2
#define ERR_NEEDSRA   3
#define ERR_NEEDSERVOP    4
#define ERR_NEEDOPER    5
#define ERR_UNKNOWNCOMMAND  6
#define RPL_MOREHELP    7
#define RPL_DEBUGHEADER   8
#define RPL_DEBUGFOOTER   9
#define RPL_DEBUGLINE1    10
#define RPL_DEBUGLINE2    11
#define ERR_BADPARAMS   12
#define RPL_PASSOKAY    13
#define RPL_YOUAREROOT    14
#define RPL_YOUARESERVOP  15
#define RPL_NOCHANGEPASS  16
#define RPL_MOREHELPCMD   17
#define RPL_PASSNOTOKAY   18
#define RPL_EMAILHACK1    19
#define RPL_EMAILHACK2    20
#define RPL_EMAILHACK3    21
#define RPL_EMAILHACK4    22
#define RPL_EMAILHACK5    23
#define RPL_EMAILHACK6    24
#define ERR_NICKNOTREGGED 25
#define RPL_INFOHEADER    26
#define RPL_INFOFOOTER    27
#define RPL_INFOBANISHED  28
#define RPL_INFONOWON   29
#define RPL_INFODEREG   30
#define RPL_INFOLASTSEEN1 31
#define RPL_INFOLASTSEEN2 32
#define RPL_INFOREGGEDON  33
#define RPL_INFOEMAIL   34
#define RPL_INFOACCESS    35
#define RPL_INFOOPTIONS   36
#define RPL_INFOMEMO    37
#define RPL_INFOLINKID    38
#define RPL_INFOCURRENTACC  39
#define RPL_INFODATA    40
#define RPL_INFOSTATUS    41
#define RPL_INFOREGBY   42
#define RPL_INFOTIMENOW   43
#define ERR_NEEDID    44
#define RPL_NSETIS    45
#define RPL_NSETNOW   46
#define ERR_BADSETTING    47
#define ERR_BADPASSWORD   48
#define RPL_PASSWORDNOW   49
#define ERR_VALIDEMAIL    50
#define ERR_NICKLIMIT   51
#define ERR_NOWEBMAIL   52
#define RPL_TEMPDEAC1   53
#define RPL_TEMPDEAC2   54
#define RPL_TEMPDEAC3   55
#define RPL_TEMPDEAC4   56
#define ERR_NOMAILSENT    57
#define ERR_ALREADYREG    58
#define ERR_NEEDTOACT   59
#define ERR_CANNOTREGTHIS 60
#define ERR_BANNEDEMAIL   61
#define ERR_CANNOTGHOSTSELF 62
#define ERR_NOTONLINE   63
#define ERR_ACCESSDENIED  64
#define RPL_NICKGHOSTED   65
#define RPL_TOCHANOPS   66
#define RPL_AUTOSET_S   67
#define RPL_NOOPSFROZEN   68
#define RPL_CHANDESC    69
#define RPL_NOOPS   70
#define RPL_PING1   71
#define RPL_PING2     72
#define ERR_CHANNOTREGGED 73
#define RPL_NEXTDBSYNC          74
#define RPL_CHANINFO1   75
#define RPL_ACTIVATE1           76
#define RPL_ACTIVATE2           77
#define RPL_ACTIVATE3           78
#define RPL_ACTIVATE4           79
#define RPL_ACTIVATE5           80
#define RPL_ACTIVATE6           81
#define RPL_REACTIVATE          82
#define RPL_ALREADYACT          83
#define RPL_NICKDROPPED         84
#define RPL_YOURACCESSIS        85
#define RPL_CHANINFO2   86
#define RPL_CHANINFO3   87
#define RPL_CHANINFO4   88
#define RPL_CHANINFO5   89
#define RPL_CHANINFO6   90
#define RPL_CHANINFO7   91
#define RPL_CHANINFO8   92
#define RPL_CHANINFO9   93
#define RPL_CHANINFO10    94
#define RPL_CHANACCESS1   95
#define RPL_CHANACCESS2   96
#define ERR_NOTOPEDINCHAN 97
#define ERR_CHANALREADYREG  98
#define ERR_TOMANYREGCHAN1  99
#define ERR_TOMANYREGCHAN2  100
#define RPL_CHANNOWREG    101
#define RPL_CHANREGNOTE   102
#define ERR_CHANFROZEN    103
#define ERR_NOOPON    104
#define RPL_CHANTRANS   105
#define RPL_ACCESSHEADER        106
#define RPL_ACCESSLIST1         107
#define RPL_ACCESSFOOTER        108
#define ERR_NOREMOTEACC   109
#define RPL_CURRENTACC    110
#define RPL_LISTOPHEADER  111
#define RPL_LISTOP1   112
#define RPL_LISTOPFOOTER  113
#define ERR_BADACCMASK    114
#define ERR_TOOMANYACCMASKS 115
#define ERR_CHANAXTOOLOW  116
#define ERR_CHANNOMOREOPS 117
#define ERR_UNKAXLEVEL    118
#define ERR_NOAXCGFOUNDER 119
#define RPL_CHANAXCHANGE  120
#define RPL_CHANOPADDED   121
#define ERR_CHANNOMOREAKICK 122
#define ERR_THISEXISTS    123
#define ERR_INVALIDAKICK  124
#define RPL_CHANAKICKADDED  125
#define ERR_NOTINOPSLIST  126
#define RPL_CHANOPDELED   127
#define ERR_AKICKNOTEXIST 128
#define RPL_CHANAKICKDELED  129
#define RPL_CHANOPSLISTHEAD1  130
#define RPL_CHANOPSLISTHEAD2  131
#define RPL_CHANOPSLISTDATA 132
#define RPL_LISTSEARCHNUM 133
#define RPL_CHANOPSLISTEND  134
#define RPL_CHANAKLISTHEAD1 135
#define RPL_CHANAKLISTHEAD2 136
#define RPL_CHANAKLISTHEAD3 137
#define RPL_CHANAKLISTDATA1 138
#define RPL_CHANAKLISTDATA2 139
#define RPL_CHANAKLISTEND 140
#define RPL_CHANDROP    141
#define ERR_NICKNOTINCHAN 142
#define RPL_NOWCHANOPERATOR 143
#define RPL_NOTCHANOPERATOR 144
#define ERR_NOSUCHCHAN    145
#define RPL_NUMUSERSINCHAN  146
#define RPL_CHANCLISTDATA 147
#define ERR_MISSINGKEY    148
#define ERR_MISSINGLIMIT  149
#define RPL_MLOCKSETTO    150
#define RPL_RESTRICTSETTO 151
#define RPL_TOPICLOCKSETTO  152
#define RPL_CHANSETSTATUS 153
#define RPL_CHANSETDESC   154
#define RPL_CHANSETDESCCLEAR  155
#define RPL_REMCHANBANS   156
#define RPL_CHANLIST    157
#define RPL_CHANMASSDEOP  158
#define RPL_CHANMASSDEVOICE 159
#define RPL_CHANMASSKICK  160
#define RPL_CHANMODECLEAR 161
#define ERR_BADMASK   162
#define RPL_AKILLADDED    163
#define ERR_MASKEXISTS    164
#define ERR_INVALIDMODES  165
#define ERR_NOSUCHSERVER  166
#define ERR_ALREADYSVSNOOP  167
#define ERR_NOTSVNOOP   168
#define RPL_EKILLEMPTY    169
#define RPL_EKILLHEAD   170
#define RPL_EKILLDATA   171
#define RPL_EKILLEND    172
#define ERR_NOSUCHEKILL   173
#define RPL_EKILLDELED    174
#define ERR_EKILLEXISTS   175
#define RPL_EKILLADDED    176
#define RPL_RESTARTING    177
#define RPL_SHUTTINGDOWN  178
#define RPL_PERMCLONEIGNHEAD  179
#define ERR_ACCMASKNOTADDED 180
#define RPL_ACCMASKADDED  181
#define RPL_ACCLISTCLEARED  182
#define RPL_ACCMASKREMOVED      183
#define ERR_ACCENTRYNOTFOUND    184
#define ERR_ACCMASKNOTFOUND     185
#define RPL_NLIST1    186
#define RPL_NLIST2    187
#define RPL_NLIST3    188
#define ERR_PROPERHOST    189
#define ERR_WIDEHOST    190
#define RPL_NLISTHEADER   191
#define RPL_NLISTFOOTER   192
#define ERR_NLISTEMPTY    193
#define RPL_NICKRELEASED  194
#define ERR_NICKNOTHELD   195
#define ERR_BADFLAG   196
#define RPL_CHANGEDFLAGS  197
#define RPL_BANNEDNICK    198
#define RPL_GETPASS   199
#define RPL_PERMCLONEIGNDATA  200
#define RPL_PERMCLONEIGNEND 201
#define RPL_UPTIME1   202
#define RPL_UPTIME2   203
#define RPL_ALLOCSTAT1    204
#define RPL_ALLOCSTAT2    205
#define RPL_CLONESTATUS1  206
#define RPL_CLONESTATUS2  207
#define ERR_INVALIDTRIGLEVEL  208
#define ERR_NOSUCHTRIGGER 209
#define RPL_NOCLONEFLAGS  210
#define RPL_HASCLONEFLAGS 211
#define ERR_PERMIGNEXISTS 212
#define ERR_NOSUCHPERMIGN 213
#define ERR_UNKNOWNFLAG   214
#define ERR_UNKNOWHOST    215
#define ERR_NOMATCH   216
#define RPL_MAPHEAD   217
#define RPL_MAPDATA   218
#define RPL_MAPMYDATA   219
#define RPL_GETKEY    220
#define RPL_GETREALPASS   221
#define RPL_DELETE    222
#define RPL_SAVE    223
#define ERR_ALREADYLINKID 224
#define ERR_MAXLINKID   225
#define RPL_NICKWARN1   226
#define RPL_NICKWARN2   227
#define RPL_NICKWARN3   228
#define RPL_NICKWARN4   229
#define RPL_NICKWARN5   230
#define RPL_HELP    231
#define RPL_YOUHAVEMEMOS  232
#define RPL_MEMO1   233
#define RPL_MEMO2   234
#define ERR_NOSUCHMEMO    235
#define RPL_MLISTHEADER   236
#define RPL_MLIST1    237
#define RPL_MLISTFOOTER   238
#define ERR_MLISTEMPTY    239
#define ERR_MEMOTOOLONG   240
#define ERR_ISNOMEMO    241
#define ERR_MEMOBOXFULL   242
#define ERR_TOOMANYMEMOS  243
#define RPL_GOTNEWMEMO    244
#define RPL_SENTMEMO    245
#define ERR_ISNOFORWARD   246
#define RPL_MEMOFORWARDED 247
#define ERR_NOFWDTOSELF   248
#define RPL_DELMEMO   249
#define RPL_DELMEMONR   250
#define RPL_MAPEND    251
#define RPL_MMAX    252
#define ERR_MMAXSET   253
#define RPL_MMAXNOW   254
#define RPL_MFORWARD    255
#define RPL_MFORWARDNOW   256
#define ERR_NOFWDMEMOS    257
#define RPL_MEMOSRETRIEVED  258
#define ERR_MNEEDLEVEL    259
#define RPL_SENTMEMOCHAN  260
#define ERR_JINXEXIST   261
#define ERR_NOSUCHNICK    262
#define ERR_CANTJINXSRA   263
#define ERR_NOSUCHJINX    264
#define RPL_JINXLISTEMPTY 265
#define RPL_JINXLISTHEADER  266
#define RPL_JINXLISTFOOTER  267
#define RPL_JINXLIST1   268
#define RPL_JINXADDED   269
#define RPL_JINXREMOVED   270
#define ERR_NEEDUSERHOST  271
#define ERR_THISISNONICKDUMMY 272
#define ERR_NOHELPONTHAT  273
#define ERR_BADCHANNELNAME  274
#define RPL_CHANCLOSED    275
#define ERR_CHANNOTCLOSED 276
#define RPL_CHANUNCLOSED  277
#define RPL_GLOBALNOTICE  278
/* Added by bobby */
#define RPL_YOUARENETADMIN 279
#define RPL_NURLDELETED    280
#define ERR_STRTOOLONG     281
#define RPL_INFOURL        282
#define RPL_ACCLISTHEADER  283
#define RPL_ACCLISTHEADER2 284
#define RPL_ACCLISTINFO    285
#define RPL_ACCLISTFOOTER  286
#define RPL_REHASHING      287
#define RPL_NEWSLISTHEADER 288
#define RPL_NEWSLISTINFO   289
#define RPL_NEWSLISTFOOTER 290
#define ERR_INVALIDNEWS    291
#define RPL_NEWSADDED      292
#define RPL_NEWSDELETED    293
#define RPL_DELALLNEWS     294
#define RPL_SHOWNEWS       295
#define RPL_CNOOPISON      296
#define RPL_CURLDELETED    297
#define ERR_CLOSESINTAX    298
#define RPL_LOGHEADER      299
#define RPL_LOGFOOTER      300
#define RPL_ROOTOPS        301
#define RPL_SOPOPS         302
#define RPL_OLISTOPHEADER  303
#define RPL_OLISTOPFOOTER  304
#define RPL_LOGINFO        305

#endif
