#ifndef __OPERSERV_H
#define __OPERSERV_H

#include "nickserv.h"

/*
 * ===DOC=== 
 * Straightforward I hope...simple AKill structure
 * nick!user@host + reason (for akill)
 */

struct akill {
  struct akill   *next, *prev;
  char            nick[NICKLEN];
  char            user[USERLEN];
  char            host[HOSTLEN];
  time_t          set;
  time_t          unset;
  char            setby[NICKLEN];
  char            reason[80];
  char            type;
  unsigned int    tid;
};

/*
#define OAKILL   0x0001
#define OIGNORE  0x0002
#define OTRIGGER 0x0004
*/
void          sendToOperServ(UserList *, char **, int);
struct akill  *isAKilled(char *, char *, char *);
struct akill  *isIgnored(char *, char *, char *);
void          addTempHost(long, char *, char *, int);
void          loadAKills(void);
void          saveAKills(void);
char          *expand_time(long);

/* OperServ commands */
void OautokillCmd(int, UserList *, char **, int);
void OcountCmd(UserList *, char **, int);  
void OmodeCmd(UserList *, char **, int);
void OrawCmd(UserList *, char **, int);
void OinjectCmd(UserList *, char **, int);
void OshutdownCmd(UserList *, char **, int);
void OrestartCmd(UserList *, char **, int);
void OjupeCmd(UserList *, char **, int);
void OsyncCmd(UserList *, char **, int);
void OuptimeCmd(UserList *, char **, int);
void OmkillCmd(UserList *,char **, int);
void OjinxCmd(UserList *, char **, int);
void OpermjinxCmd(UserList *, char **, int);
void OhostjinxCmd(UserList *, char **, int);
void ObroadcastCmd(UserList *, char **, int);
void OmapCmd(UserList *, char **, int);
void OekillCmd(UserList *, char **, int);
void OlistCmd(UserList *, char **, int);
void OsvsnoopCmd(UserList *, char **, int);
void OenforceCmd(UserList *, char **, int);
void OlogaccessCmd(UserList *, char **, int);
void OallocstatCmd(UserList *, char **, int);
void OtriggerCmd(UserList *, char **, int);
void OclonesetCmd(UserList *, char **, int);
void OrehashCmd(UserList *, char **, int);
void OlogonnewsCmd(UserList *, char **, int);
void OopernewsCmd(UserList *, char **, int);
void OrootopsCmd(UserList *, char **, int);
void OsopopsCmd(UserList *, char **, int);
void OlistopsCmd(UserList *, char **, int);

#endif /* __OPERSERV_H */
