#ifndef __CLONE_H
#define __CLONE_H

typedef struct userclonestruct UserClone;
struct userclonestruct {
  char user[USERLEN];
  int clones, trigger, roleplay;
  UserClone *next, *previous;
};

typedef struct hostclonestruct HostClone;
struct hostclonestruct {
  char host[HOSTLEN];
  UserClone *firstUser, *lastUser;
  int trigger;
  int clones;
  int flags;
  HostClone *next, *previous, *hashnext, *hashprev;
};

typedef struct hostcloneliststruct HostCloneList;
struct hostcloneliststruct {
  char host[HOSTLEN];
  char setby[NICKLEN];
  time_t setwhen;
  HostCloneList *next, *prev;
};
HostCloneList *firstPermClone;

int addClone(char *, char *, char *);
void delClone(char *, char *);
HostClone *getCloneData(char *);
int addUserClone(HostClone *, char *);
void delUserClone(HostClone *, UserClone *);
UserClone *getUserCloneData(HostClone *, char *);
void initCloneData(HostClone *);
int killMassClones(char *, char *);
void loadpermignores();
void savepermignores();

int maskchecksum(char *);
int str2array(char **, char *, char *);
char *maskme(char *);
char *maskuser(UserList *);
char *maskreguser(RegNickList *);

/*
 *  In this structure is where we keep track of all servers that have been linked to us.
 */

typedef struct Server aServer;
struct Server {
  char name[HOSTLEN];
  char version[NICKLEN*2];
  int svsnoop;
  aServer *next, *prev;
};
aServer *ServerList;

void AddServer(char *, char *);
int CheckServer(char *);
aServer *GetServer(char *);
void DeleteServer(char *);
void free_server(aServer *);
aServer *make_server();

/*
 *
 * In this structure is where we keep all email addresses we dont like -GZ.
 *
 */

typedef struct Email anEmail;
struct Email {
  char email[EMAILLEN];
  char by[NICKLEN];
  time_t time;
  char reason[512];
  anEmail *next, *prev;
};
anEmail *EmailList;

void AddEmail(char *, char *, char *);
int CheckEmail(char *);
int VerifyEmail(char *);
void DeleteEmail(char *);
void free_email(anEmail *);
anEmail *make_email();
void loaddynamicekills();
void savedynamicekills();
void flushlogs();

#endif
